/**
 * AUSF API
 * AUSF UE Authentication Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 1.1.1
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

/*
 * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The OpenAirInterface Software Alliance licenses this file to You under
 * the OAI Public License, Version 1.1  (the "License"); you may not use this
 *file except in compliance with the License. You may obtain a copy of the
 *License at
 *
 *      http://www.openairinterface.org/?page_id=698
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *-------------------------------------------------------------------------------
 * For more information about the OpenAirInterface (OAI) Software Alliance:
 *      contact@openairinterface.org
 */

/*
 * AuthenticationResultDeletionApi.h
 *
 *
 */

#ifndef AuthenticationResultDeletionApi_H_
#define AuthenticationResultDeletionApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "ProblemDetails.h"
#include <string>

namespace oai {
namespace ausf_server {
namespace api {

using namespace oai::ausf_server::model;

class AuthenticationResultDeletionApi {
 public:
  AuthenticationResultDeletionApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~AuthenticationResultDeletionApi() {}
  void init();

  const std::string base = "/nausf-auth/v1";

 private:
  void setupRoutes();

  void delete5g_aka_authentication_result_handler(
      const Pistache::Rest::Request& request,
      Pistache::Http::ResponseWriter response);
  void delete_eap_authentication_result_handler(
      const Pistache::Rest::Request& request,
      Pistache::Http::ResponseWriter response);
  void authentication_result_deletion_api_default_handler(
      const Pistache::Rest::Request& request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Deletes the authentication result in the UDM
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="authCtxId"></param>
  virtual void delete5g_aka_authentication_result(
      const std::string& authCtxId,
      Pistache::Http::ResponseWriter& response) = 0;

  /// <summary>
  /// Deletes the authentication result in the UDM
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="authCtxId"></param>
  virtual void delete_eap_authentication_result(
      const std::string& authCtxId,
      Pistache::Http::ResponseWriter& response) = 0;
};

}  // namespace api
}  // namespace ausf_server
}  // namespace oai

#endif /* AuthenticationResultDeletionApi_H_ */
